Name:           ros-kilted-gz-common-vendor
Version:        0.2.3
Release:        1%{?dist}
Summary:        ROS package gz-common-vendor

License:        Apache License 2.0
URL:            https://github.com/gazebosim/gz-common

Source0:        https://github.com/ros2-gbp/gz_common_vendor-release/archive/release/kilted/gz_common_vendor/0.2.3-2.tar.gz#/ros-kilted-gz-common-vendor-0.2.3-source0.tar.gz

Patch0: ros.gz_common_vendor.include_cstdint_kilted.patch


# common BRs
BuildRequires: patchelf
BuildRequires: coreutils
BuildRequires: cmake
BuildRequires: gcc-c++
BuildRequires: git
BuildRequires: make
BuildRequires: patch
BuildRequires: python3-devel
BuildRequires: python-unversioned-command
BuildRequires: python3-colcon-common-extensions
BuildRequires: python3-pip
BuildRequires: python3-pydocstyle
BuildRequires: python3-pytest
BuildRequires: python3-pytest-repeat
BuildRequires: python3-pytest-rerunfailures
BuildRequires: python3-rosdep
BuildRequires: python3-setuptools
BuildRequires: python3-vcstool

# BuildRequires:  boost-devel
# BuildRequires:  console-bridge-devel
# BuildRequires:  gtest-devel
# BuildRequires:  log4cxx-devel
# BuildRequires:  python3-devel
# BuildRequires:  python3-colcon-common-extensions
# BuildRequires:  python-unversioned-command

BuildRequires:  assimp-devel
BuildRequires:  cmake
BuildRequires:  ffmpeg-free-devel
BuildRequires:  freeimage-devel
BuildRequires:  gdal-devel
BuildRequires:  gts-devel
BuildRequires:  libuuid-devel
BuildRequires:  pkgconfig
BuildRequires:  tinyxml2-devel
BuildRequires:  ros-kilted-ament-cmake-core
BuildRequires:  ros-kilted-ament-cmake-test
BuildRequires:  ros-kilted-ament-cmake-vendor-package
BuildRequires:  ros-kilted-ament-package
BuildRequires:  ros-kilted-gz-cmake-vendor
BuildRequires:  ros-kilted-gz-math-vendor
BuildRequires:  ros-kilted-gz-utils-vendor
BuildRequires:  ros-kilted-spdlog-vendor

Requires:       ros-kilted-gz-cmake-vendor
Requires:       ros-kilted-gz-math-vendor
Requires:       ros-kilted-gz-utils-vendor
Requires:       ros-kilted-spdlog-vendor

Requires:       cmake
Requires:       pkgconfig
Requires:       ros-kilted-ament-cmake-core
Requires:       ros-kilted-ament-cmake-test
Requires:       ros-kilted-ament-cmake-vendor-package
Requires:       assimp-devel
Requires:       ffmpeg-free-devel
Requires:       freeimage-devel
Requires:       gdal-devel
Requires:       gts-devel
Requires:       libuuid-devel
Requires:       tinyxml2-devel
Requires:       ros-kilted-ament-package
Requires:       ros-kilted-gz-cmake-vendor
Requires:       ros-kilted-gz-math-vendor
Requires:       ros-kilted-gz-utils-vendor
Requires:       ros-kilted-spdlog-vendor

Provides:  ros-kilted-gz-common-vendor = 0.2.3-1
Obsoletes: ros-kilted-gz-common-vendor < 0.2.3-1


%description
Vendor package for: gz-common6 6.0.2 Gazebo Common : AV, Graphics,
Events, and much more.




%prep

%setup -c -T
tar --strip-components=1 -xf %{SOURCE0}
%patch 0 -p1

%build
# nothing to do here


%install

PYTHONUNBUFFERED=1 ; export PYTHONUNBUFFERED
GZ_BUILD_FROM_SOURCE=1; export GZ_BUILD_FROM_SOURCE
export GZ_VERSION=harmonic;

CFLAGS=" -Wno-error ${CFLAGS:-%optflags} -Wno-error -w -Wno-error=int-conversion" ; export CFLAGS ; \
CXXFLAGS=" -Wno-error ${CXXFLAGS:-%optflags} -Wno-error -w -Wno-error=int-conversion" ; export CXXFLAGS ; \
FFLAGS=" -Wno-error ${FFLAGS:-%optflags%{?_fmoddir: -I%_fmoddir}} -w -Wno-error=int-conversion" ; export FFLAGS ; \
FCFLAGS="${FCFLAGS:-%optflags%{?_fmoddir: -I%_fmoddir}} -w -Wno-error=int-conversion" ; export FCFLAGS ; \
%{?__global_ldflags:LDFLAGS="${LDFLAGS:-%__global_ldflags}" ; export LDFLAGS ;} \

source %{_libdir}/ros-kilted/setup.bash

# substitute shebang before install block because we run the local catkin script
%py3_shebang_fix .

# DESTDIR=%{buildroot} ; export DESTDIR

colcon \
  build \
  --merge-install \
  --cmake-args -DPYTHON_EXECUTABLE="/usr/bin/python" \
  -DTHIRDPARTY_Asio=ON \
  -DCMAKE_BUILD_TYPE=RelWithDebInfo \
  -DCMAKE_CXX_FLAGS="$CXXFLAGS" \
  -DCMAKE_C_FLAGS="$CFLAGS" \
  -DCMAKE_LD_FLAGS="$LDFLAGS" \
  -DBUILD_TESTING=OFF \
  -Dgz_add_get_install_prefix_impl_OVERRIDE_INSTALL_PREFIX_ENV_VARIABLE="%{_libdir}/ros-kilted/opt/" \
  --base-paths . \
  --install-base %{buildroot}/%{_libdir}/ros-kilted/ \
  --packages-select gz_common_vendor



# remove wrong buildroot prefixes
# find %{buildroot}/%{_libdir}/ros-kilted/ -type f -exec sed -i "s:%{buildroot}::g" {} \;
# we should exclude binaries from that as it might corrupt shared libraries
find %{buildroot}/%{_libdir}/ros-kilted/ -type f ! -name '*.so*' -exec sh -c 'file "{}" | grep -q text && sed -i "s:%{buildroot}::g" "{}"' \;

# # Move include directory if source path exists
# if [ -d %{buildroot}/%{_libdir}/ros-kilted/opt/gz_common_vendor/include ]; then
#     # If destination path does not exist, create it
#     if [ ! -d %{buildroot}/%{_libdir}/ros-kilted/include/gz_common_vendor ]; then
#         mkdir -p %{buildroot}/%{_libdir}/ros-kilted/include/gz_common_vendor
#     fi
#     # Move the directory
#     cp -r %{buildroot}/%{_libdir}/ros-kilted/opt/gz_common_vendor/include/* %{buildroot}/%{_libdir}/ros-kilted/include/gz_common_vendor/
#     rm -rd %{buildroot}/%{_libdir}/ros-kilted/opt/gz_common_vendor/include
# fi

# if [ -d %{buildroot}/%{_libdir}/ros-kilted/opt/gz_common_vendor/extra_cmake ]; then
#     # If destination path does not exist, create it
#     if [ ! -d %{buildroot}/%{_libdir}/ros-kilted/gz_common_vendor/extra_cmake ]; then
#         mkdir -p %{buildroot}/%{_libdir}/ros-kilted/gz_common_vendor/extra_cmake
#     fi
#     # Move the directory
#     cp -r %{buildroot}/%{_libdir}/ros-kilted/opt/gz_common_vendor/extra_cmake/* %{buildroot}/%{_libdir}/ros-kilted/gz_common_vendor/extra_cmake/
#     rm -rd %{buildroot}/%{_libdir}/ros-kilted/opt/gz_common_vendor/extra_cmake
# fi

# if [ -d %{buildroot}/%{_libdir}/ros-kilted/gz_common_vendor/share ]; then
#     # If destination path does not exist, create it
#     if [ ! -d %{buildroot}/%{_libdir}/ros-kilted/share/gz_common_vendor ]; then
#         mkdir -p %{buildroot}/%{_libdir}/ros-kilted/share/gz_common_vendor
#     fi
#     # Move the directory
#     cp -r %{buildroot}/%{_libdir}/ros-kilted/gz_common_vendor/share/* %{buildroot}/%{_libdir}/ros-kilted/share/gz_common_vendor/
#     rm -rd %{buildroot}/%{_libdir}/ros-kilted/gz_common_vendor/share
# fi

# # Move other opt path if source path exists
# if [ -d %{buildroot}/%{_libdir}/ros-kilted/opt/gz_common_vendor]; then
#     # If destination path does not exist, create it
#     if [ ! -d %{buildroot}/%{_libdir}/ros-kilted ]; then
#         mkdir -p %{buildroot}/%{_libdir}/ros-kilted
#     fi
#     # Move the directory
#     cp -r %{buildroot}/%{_libdir}/ros-kilted/opt/gz_common_vendor/* %{buildroot}/%{_libdir}/ros-kilted/
#     rm  -rd %{buildroot}/%{_libdir}/ros-kilted/opt/gz_common_vendor
# fi

rm -rf %{buildroot}/%{_libdir}/ros-kilted/{.catkin,.rosinstall,_setup*,local_setup*,setup*,env.sh,.colcon_install_layout,COLCON_IGNORE,_local_setup*,_local_setup*}

# vendor pkg removal
rm -rf %{buildroot}/%{_libdir}/ros-kilted/opt/share/gz_common_vendor/{.catkin,.rosinstall,_setup*,local_setup*,setup*,env.sh,.colcon_install_layout,COLCON_IGNORE,_local_setup*,_local_setup*}

# remove __pycache__
find %{buildroot} -type d -name '__pycache__' -exec rm -rf {} +
find . -name '*.pyc' -delete

touch files.list
find %{buildroot}/%{_libdir}/ros-kilted/{share,bin,etc,tools,lib64/python*,lib/python*/site-packages,lib/python*/dist-packages} \
  ! -name cmake ! -name include \
  -mindepth 1 -maxdepth 1 | sed "s:%{buildroot}/::" > files.list
find %{buildroot}/%{_libdir}/ros-kilted/lib*/ -mindepth 1 -maxdepth 1 \
  ! -name pkgconfig ! -name "python*" \
  | sed "s:%{buildroot}/::" >> files.list

# paths for vendor packages
find %{buildroot}/%{_libdir}/ros-kilted/gz_common_vendor/{bin,etc,tools,lib64/python*,lib/python*/site-packages,share} \
  ! -name cmake ! -name include \
  -mindepth 1 -maxdepth 1 | sed "s:%{buildroot}/::" >> files.list
find %{buildroot}/%{_libdir}/ros-kilted/opt/gz_common_vendor/{bin,etc,tools,lib64/python*,lib/python*/site-packages,share} \
  ! -name cmake ! -name include \
  -mindepth 1 -maxdepth 1 | sed "s:%{buildroot}/::" >> files.list
find %{buildroot}/%{_libdir}/ros-kilted/gz_common_vendor/lib*/ -mindepth 1 -maxdepth 1 \
  ! -name pkgconfig ! -name "python*" \
  | sed "s:%{buildroot}/::" >> files.list
find %{buildroot}/%{_libdir}/ros-kilted/opt/gz_common_vendor/lib*/ -mindepth 1 -maxdepth 1 \
  ! -name pkgconfig ! -name "python*" \
  | sed "s:%{buildroot}/::" >> files.list
find %{buildroot}/%{_libdir}/ros-kilted/opt/share/gz_common_vendor \
  -mindepth 1 -maxdepth 1 | sed "s:%{buildroot}/::" >> files.list

find %{buildroot}/%{_libdir}/ros-kilted/{lib*/pkgconfig,include/,cmake/,gz_common_vendor/include/,share/gz_common_vendor/cmake} \
  -mindepth 1 -maxdepth 1 | sed "s:%{buildroot}/::" >> files.list
# paths for vendor packages
find %{buildroot}/%{_libdir}/ros-kilted/gz_common_vendor/{lib*/pkgconfig,include/,cmake/,extra_cmake/,gz_common_vendor/include/,share/cmake} \
  -mindepth 1 -maxdepth 1 | sed "s:%{buildroot}/::" >> files.list
find %{buildroot}/%{_libdir}/ros-kilted/opt/gz_common_vendor/extra_cmake \
  -mindepth 1 -maxdepth 1 | sed "s:%{buildroot}/::" >> files.list
find %{buildroot}/%{_libdir}/ros-kilted/opt/gz_common_vendor/{lib*/pkgconfig,include/,cmake/,gz_common_vendor/include/,/share/cmake,/extra_cmake} \
  -mindepth 1 -maxdepth 1 | sed "s:%{buildroot}/::" >> files.list
find %{buildroot}/%{_libdir}/ros-kilted/opt/share/ament_index/resource_index \
  -mindepth 1 -maxdepth 1 | sed "s:%{buildroot}/::" >> files.list
find %{buildroot}/%{_libdir}/ros-kilted/opt/share/colcon-core/packages/ \
  -mindepth 1 -maxdepth 1 | sed "s:%{buildroot}/::" >> files.list
find %{buildroot}/%{_libdir}/ros-kilted/opt/share/gz_common_vendor/{hook,environment,cmake} \
  -mindepth 1 -maxdepth 1 | sed "s:%{buildroot}/::" >> files.list
find . -maxdepth 1 -type f -iname "*license*" | sed "s:^:%%license :" >> files.list



find %{buildroot}/%{_libdir}/ros-kilted/ -name *__rosidl_generator_py.so -type f -exec patchelf --remove-rpath  {} \;
# find %{buildroot}/%{_libdir}/ros-kilted/ -name *__rosidl_generator_py.so -type f -exec patchelf --force-rpath --add-rpath "%{_libdir}/ros2/lib" {} \;
find %{buildroot}/%{_libdir}/ros-kilted/ -name "*.so*" -type f -exec patchelf  --shrink-rpath --allowed-rpath-prefixes %{_libdir} {} \;

# replace cmake python macro in shebang
for file in $(grep -rIl '^#!.*@PYTHON_EXECUTABLE@.*$' %{buildroot}) ; do
  sed -i.orig 's:^#!\s*@PYTHON_EXECUTABLE@\s*:%{__python3}:' $file
  touch -r $file.orig $file
  rm $file.orig
done


echo "This is a package automatically generated with rosfed." >> README_FEDORA
echo "See  https://github.com/TarikViehmann/rosfed for more information." >> README_FEDORA
install -m 0644 -p -D -t %{buildroot}/%{_docdir}/%{name} README_FEDORA
echo %{_docdir}/%{name} >> files.list

%py3_shebang_fix %{buildroot}

# Also fix .py.in files
for pyfile in $(grep -rIl '^#!.*python.*$' %{buildroot}) ; do
  %py3_shebang_fix $pyfile
done

sort files.list | uniq > files.list.tmp && mv files.list.tmp files.list

%files -f files.list


%changelog
* Sun Jun 22 2025 Tarik Viehmann <viehmann@kbsg.rwth-aachen.de> - kilted.0.2.3-1
- Update to latest release
